/*
 * @(#)dollar_put_1.cs
 *  $B=R8l(B $put/1
 */

namespace JJC.Psharp.Predicates {

	using JJC.Psharp.Lang;

	public sealed class dollar_put_1 : Predicate {
		Term arg1;

		public dollar_put_1(Term a1, Predicate cont) {
			arg1 = a1;
			this.cont = cont;
		}
		public dollar_put_1() {}
		public override void setArgument(Term[] args, Predicate cont){
			arg1 = args[0];
			this.cont = cont;
		}

		public override Predicate exec( Prolog engine ) {
			try {
				char ch = (char)(engine.evalTerm(arg1));
				engine.current_output.Write(ch);
			} catch (ArithException) {
				return engine.abort("{TYPE ERROR: " + this + 
					" - arg 1: expected expression, found " +
					arg1 + "}");
			}
			return cont;
		}

		public override int arity() { return 1; }
		public override string ToString() {
			return "$put(" + arg1 + ")";
		}	
	}

}