/*
 *  @(#)Predicate.cs 
 */

/* 
 * @author Mutsunori Banbara 
 *         banbara@pascal.seg.kobe-u.ac.jp
 *         Nara National College of Technology
 * @author Naoyuki Tamura 
 *         tamura@kobe-u.ac.jp
 *         Kobe University
 */

namespace JJC.Psharp.Lang {

	public interface FcoPredicate {
		Predicate call( Prolog engine );
	}

	public abstract class Predicate {
		// protected Prolog cafe = null;
		// protected Prolog engine = null;
		
		protected Predicate cont = null;

		// abstract public Predicate exec( ); /* NOW TEMP */
		abstract public Predicate exec( Prolog engine );

		abstract public int arity();
		// *JJC* PUT BACK SOMETIME abstract public void setArgument(Term[] args, Predicate cont);
		public virtual void setArgument(Term[] args, Predicate cont) {
		}
		//public void setEngine( Prolog engine ) {
		//	this.engine = engine;
		//}
	}

}