/*
 *  @(#) dollar_flushOutput_0.cs
 *  $B=R8l(B $flush_output/0
 */

namespace JJC.Psharp.Predicates {

	using JJC.Psharp.Lang;

	using System.IO;

	public sealed class dollar_flushOutput_0 : Predicate {

		public dollar_flushOutput_0(Predicate cont) {
			this.cont = cont;
		}
		public dollar_flushOutput_0() {}
		public override void setArgument(Term[] args, Predicate cont){
			this.cont = cont;
		}

		public override Predicate exec( Prolog engine ) {
			engine.current_output.Flush();
			return cont;
		}

		public override int arity() { return 0; }
		public override string ToString() {
			return "$flush_output";
		}
	}

}