
namespace JJC.Psharp.Predicates {

	using JJC.Psharp.Lang;
	using System.Reflection;

	public sealed class dollar_loadAssembly_1 : Predicate {
		Term arg1;

		public dollar_loadAssembly_1(Term a1, Predicate cont) {
			arg1 = a1;
			this.cont = cont;
		}
		public dollar_loadAssembly_1() {}
		public override void setArgument(Term[] args, Predicate cont){
			arg1 = args[0];
			this.cont = cont;
		}

		public override Predicate exec( Prolog engine ) {
			Term a1;
			//Term a2;
			a1 = arg1.dereference();
			//a2 = arg2.dereference();
			//CsObjectTerm jTerm;
			
			if( a1.isSymbol( ) ) {
				try {
					System.Reflection.Assembly ass = 
						System.Reflection.Assembly.Load( ((SymbolTerm)a1).name );
					if( ass == null )
						return engine.fail( );
					else 
						AssemblyList.Add( ass );
				} catch {
					return engine.fail( );
				}
				// jTerm = new CsObjectTerm( ass);
				//if ( !a2.unify(jTerm, engine.trail) ) 
				//	return engine.fail();
				return cont;
			} else if( a1.isCsObject( ) ) {
				try {
					AssemblyList.Add( (Assembly)( ( (CsObjectTerm)a1 ).Object( ) ) );
					return cont;
				}
				catch {
					return engine.fail( );
				}
			} else
				return engine.fail( );
		}

		public override int arity() { return 1; }

		public override string ToString() {
			return "$load_assembly(" + arg1 + ")";
		}
	}
}